#include <iostream>
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include <SDL2/SDL_thread.h>
#include <SDL2/SDL_ttf.h>
#include <SDL2/SDL_mixer.h>
#include <stdlib.h>
#include <fstream>
#include <string>
#include <sstream> 
#include <filesystem>
#include <algorithm>
#define Maximum(a, b) ((a > b) ? a : b)
#define Minimum(a, b) ((a < b) ? a : b)

SDL_DisplayMode DMode;
SDL_Window* Window = NULL;
SDL_Renderer* Renderer = NULL; //mystic thing, brings an image to the screen
SDL_Surface* CurrentSurface = NULL;
SDL_Surface* ScreenSurface = NULL; 
SDL_Rect Reader;
SDL_Rect Writer;
SDL_Event event;
std::string speicher;
TTF_Font *gFont[5];
int FullScreen=true;
bool AntiA=true;
bool running=true;
bool Mono=false;
int MedianMode=1; //0=Ratio, 1=Median, 2=Color Pick
float MedianPoint=0.5;
bool PaletteMode=false;
float Zoomfactor=1;
bool SetRefresh=true;

SDL_Texture* Images[1000];

int Scrollpoint=0;

int RefreshTimer=1;
SDL_Surface* RawImages[1000];
int texturesUsed=0;
int LoadMode=2;
int PixelSize=20;
int PaletteSelect=1;

int CTex=1;

SDL_Color CArr[10000];
SDL_Color CArr2[10000];

short int RArr[100000];
short int BArr[100000];
short int GArr[100000];

float RefX=100;
float RefY=100;
float RefZ=100;

std::string Paths[1000];
int Pathn=0;

std::string ProPaths[1000];
int ProPathn=0;

std::string PalPaths[1000];
int PalPathn=0;

bool Inmode=false;
int InTarg=1;
std::string Input;

class Button
{
	public:
	bool Unlocked=false;
	int x=0;
	int y=0;
	int w=200;
	int h=100;
	int Action=0;
	SDL_Texture *TitleTex;
	std::string Text="";
	std::string LastText="";
	bool Solid=false;
	SDL_Color BGColor{0, 0, 0, 0};
	SDL_Color FontColor{0, 255, 0, 255};
	SDL_Color LastFontColor{0, 255, 0, 255};
	int CreateText(SDL_Renderer* rend=Renderer)
	{
		SDL_DestroyTexture(TitleTex);
		SDL_Surface* Result=NULL;
		TTF_Font *tFont;
		tFont=TTF_OpenFont( "bebas-neue/BebasNeue-Regular.otf", h );
		Result=TTF_RenderText_Solid(tFont, Text.c_str(), FontColor);	
		TitleTex=SDL_CreateTextureFromSurface(rend, Result);		
		SDL_FreeSurface(Result);
		TTF_CloseFont(tFont);
		return 0;
	}
	
	int Draw(SDL_Renderer* rend=Renderer)
	{
		SDL_Rect Drawer;
		Drawer.x=x;
		Drawer.y=y;
		Drawer.w=w;
		Drawer.h=h;
		SDL_SetRenderDrawColor(rend, BGColor.r, BGColor.g, BGColor.b, BGColor.a);
		if(Solid==false)
		SDL_RenderDrawRect(rend, &Drawer);
		else
		SDL_RenderFillRect(rend, &Drawer);
		
		if(strcmp(Text.c_str(), LastText.c_str())!=0 || (LastFontColor.r!=FontColor.r || LastFontColor.g!=FontColor.g||LastFontColor.r!=FontColor.b||LastFontColor.a!=FontColor.a))
		{
			CreateText(rend);
			LastText=Text;
			LastFontColor=FontColor;
		}
		if(strcmp(Text.c_str(), "")!=0)
		{
			 SDL_Point size;
			SDL_QueryTexture(TitleTex, NULL, NULL, &size.x, &size.y);
			 Drawer.w=size.x;
			 Drawer.h=size.y;
			 SDL_RenderCopy( rend, TitleTex, NULL, &Drawer);

		}
		
		
		return 0;
	}
	
};

Button ButtonS[500];



class Palette
{
	public:
	 SDL_Color Clrs[1000];
	 SDL_Color ClrPoints[1000];
	 int ActiveClrs=0;
	 std::string Name;
	 
	 float DistToColor(float r, float g, float b, int n)
	 {
		 float re=0;
		 float var_R = ( r / 255 );
		 float var_G = ( g / 255 );
		 float var_B = ( b / 255 );

		if (var_R>0.04045) 
		var_R = std::pow(((var_R+0.055)/ 1.055 ), 2.4);
		else var_R = var_R / 12.92;
		if ( var_G > 0.04045 ) var_G = std::pow(( ( var_G + 0.055 ) / 1.055 ), 2.4);
		else var_G = var_G / 12.92;
		if ( var_B > 0.04045 ) var_B = std::pow(( ( var_B + 0.055 ) / 1.055 ), 2.4);
		else var_B = var_B / 12.92;

		var_R = var_R * 100;
		var_G = var_G * 100;
		var_B = var_B * 100;

		float X = (var_R * 0.4124) + (var_G * 0.3576) + (var_B * 0.1805);
		float Y = (var_R * 0.2126) + (var_G * 0.7152) + (var_B * 0.0722);
		float Z = (var_R * 0.0193) + (var_G * 0.1192) + (var_B * 0.9505);
		
		
		float r2=ClrPoints[n].r;
		float g2=ClrPoints[n].g;
		float b2=ClrPoints[n].b;
		 var_R = (float)( r2 / 255 );
		 var_G = (float)( g2 / 255 );
		 var_B = (float)( b2 / 255 );
		 
		

		if (var_R>0.04045) 
		var_R = std::pow(((var_R+0.055)/ 1.055 ), 2.4);
		else var_R = var_R / 12.92;
		if ( var_G > 0.04045 ) var_G = std::pow(( ( var_G + 0.055 ) / 1.055 ), 2.4);
		else var_G = var_G / 12.92;
		if ( var_B > 0.04045 ) var_B = std::pow(( ( var_B + 0.055 ) / 1.055 ), 2.4);
		else var_B = var_B / 12.92;

		var_R = var_R * 100;
		var_G = var_G * 100;
		var_B = var_B * 100;

		float X2 = (var_R * 0.4124) + (var_G * 0.3576) + (var_B * 0.1805);
		float Y2 = (var_R * 0.2126) + (var_G * 0.7152) + (var_B * 0.0722);
		float Z2 = (var_R * 0.0193) + (var_G * 0.1192) + (var_B * 0.9505);
		
		float var_X = X / RefX;
		float var_Y = Y / RefY;
		float var_Z = Z / RefZ;

		if ( var_X > 0.008856 ) var_X = std::pow(var_X, ( 0.3333333333333 ));
		else var_X = ( 7.787 * var_X ) + ( 16 / 116 );
		if ( var_Y > 0.008856 ) var_Y = std::pow(var_Y, ( 0.3333333333333 ));
		else var_Y = ( 7.787 * var_Y ) + ( 16 / 116 );
		if ( var_Z > 0.008856 ) var_Z = std::pow(var_Z, ( 0.3333333333333 ));
		else var_Z = ( 7.787 * var_Z ) + ( 16 / 116 );

		float L1 = ( 116 * var_Y ) - 16;
		float A1 = 500 * ( var_X - var_Y );
		float B1 = 200 * ( var_Y - var_Z );
		
		
		
		 var_X = X2 / RefX;
		 var_Y = Y2 / RefY;
		 var_Z = Z2 / RefZ;

		if ( var_X > 0.008856 ) var_X = std::pow(var_X, ( 0.3333333333333 ));
		else var_X = ( 7.787 * var_X ) + ( 16 / 116 );
		if ( var_Y > 0.008856 ) var_Y = std::pow(var_Y, ( 0.3333333333333 ));
		else var_Y = ( 7.787 * var_Y ) + ( 16 / 116 );
		if ( var_Z > 0.008856 ) var_Z = std::pow(var_Z, ( 0.3333333333333 ));
		else var_Z = ( 7.787 * var_Z ) + ( 16 / 116 );

		float L2 = ( 116 * var_Y ) - 16;
		float A2 = 500 * ( var_X - var_Y );
		float B2 = 200 * ( var_Y - var_Z );
		// std::cout << "r: " << r2 << "g: " << g2 << "b: " << b2 << " | L:" << L2 << "A: " << A2 << "B: " << B2 << std::endl; 
		re=sqrt(((L1-L2)*(L1-L2))+((A1-A2)*(A1-A2))+((B1-B2)*(B1-B2)));
		 
		 //float re=sqrt((0.3*((r-ClrPoints[n].r)*(r-ClrPoints[n].r)))+(0.59*((g-ClrPoints[n].g)*(g-ClrPoints[n].g)))+(0.11*((b-ClrPoints[n].b)*(b-ClrPoints[n].b))));
		 return re;
	 }
	 
	 int GetNearestColor(int r, int g, int b)
	 {
		float pick=99999999;
		int picked=0;
		for(int i=1; i<ActiveClrs+1; i++)
		{
			if(DistToColor(r, g, b, i)<pick)
			{
				pick=DistToColor(r, g, b, i);
				picked=i;
			}
			
		}
		return picked;
	 }
	 
	 int AddColor(int r, int g, int b, int rP=-1, int gP=-1, int bP=-1)
	 {
		 ActiveClrs++;
		 Clrs[ActiveClrs].r=r;
		 Clrs[ActiveClrs].g=g;
		 Clrs[ActiveClrs].b=b;
		 if(rP==-1)ClrPoints[ActiveClrs].r=r;
		 else ClrPoints[ActiveClrs].r=rP;
		 if(gP==-1)ClrPoints[ActiveClrs].g=g;
		 else ClrPoints[ActiveClrs].g=gP;
		 if(bP==-1)ClrPoints[ActiveClrs].b=b;
		 else ClrPoints[ActiveClrs].b=bP;
		 return 0;
	 }
	
};

Palette cPal;
Palette PaletteStack[1000];
int APals=0;


int loadPalettes(std::string mainfile)
{
			std::ifstream file;
	
			std::string str;
	
			file.open(mainfile.c_str());
			while (std::getline(file, str))
			{
			char * writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
			if(speicher=="NewPal"){APals++; PaletteStack[APals].ActiveClrs=0; PaletteStack[APals].Name=str;}
			if(speicher=="AddColor"){PaletteStack[APals].ActiveClrs++;}
			if(speicher=="R"){PaletteStack[APals].Clrs[PaletteStack[APals].ActiveClrs].r=atoi(str.c_str()); PaletteStack[APals].ClrPoints[PaletteStack[APals].ActiveClrs].r=atoi(str.c_str());}
			if(speicher=="G"){PaletteStack[APals].Clrs[PaletteStack[APals].ActiveClrs].g=atoi(str.c_str()); PaletteStack[APals].ClrPoints[PaletteStack[APals].ActiveClrs].g=atoi(str.c_str());}
			if(speicher=="B"){PaletteStack[APals].Clrs[PaletteStack[APals].ActiveClrs].b=atoi(str.c_str()); PaletteStack[APals].ClrPoints[PaletteStack[APals].ActiveClrs].b=atoi(str.c_str());}
			if(speicher=="RP"){PaletteStack[APals].ClrPoints[PaletteStack[APals].ActiveClrs].r=atoi(str.c_str());}
			if(speicher=="GP"){PaletteStack[APals].ClrPoints[PaletteStack[APals].ActiveClrs].g=atoi(str.c_str());}
			if(speicher=="BP"){PaletteStack[APals].ClrPoints[PaletteStack[APals].ActiveClrs].b=atoi(str.c_str());}
				delete[] writable;
				speicher=str;
			}
		file.close();	
		
		return 0;
}



SDL_Surface* crop_surface(SDL_Surface* surfer, int w, int h)
{
SDL_Surface* surface = SDL_CreateRGBSurface(surfer->flags, w, h, surfer->format->BitsPerPixel, surfer->format->Rmask, surfer->format->Gmask, surfer->format->Bmask, surfer->format->Amask);
SDL_Rect rect = {0, 0, w, h};
SDL_BlitSurface(surfer, &rect, surface, 0);
return surface;
}

int CValue(SDL_Color c1)
{
	int sum=c1.r+c1.g+c1.b;
	return sum;
}

int SortColors(int Size)
{
	/*
	bool doer=true;
	while(doer==true)
	{
		doer=false;
		for(int i=0; i<Size; i++)
		{
			if(CValue(CArr[i])>CValue(CArr[i+1]))
			 {
				 std::swap(CArr[i], CArr[i+1]);
				 doer=true; 
			 }
			
		}
	}*/
	std::sort(RArr, RArr+Size);
	std::sort(BArr, BArr+Size);
	std::sort(GArr, GArr+Size);
	return 0;
}

int GetInputList()
{
	 std::string path = "Input";
	 
    for (const auto & entry : std::filesystem::directory_iterator(path))
    {
		Pathn++;
        Paths[Pathn]=entry.path().string();
        RawImages[Pathn] = IMG_Load( entry.path().string().c_str() ); 
        //std::cout << Paths[Pathn] << std::endl;
	}
	return 0;

}

int GetProfileList()
{
	 std::string path = "Profiles";
	 
    for (const auto & entry : std::filesystem::directory_iterator(path))
    {
		ProPathn++;
        ProPaths[ProPathn]=entry.path().string();
        //std::cout << Paths[Pathn] << std::endl;
	}
	return 0;

}

int GetPaletteList()
{
	 std::string path = "Palettes";
	 
    for (const auto & entry : std::filesystem::directory_iterator(path))
    {
		PalPathn++;
        PalPaths[ProPathn]=entry.path().string();
        loadPalettes(entry.path().string().c_str());
        //std::cout << Paths[Pathn] << std::endl;
	}
	return 0;

}

int Recoulor(SDL_Surface* Surf, SDL_Texture** give, bool clean=true, int Save=0)	//this is crazy!
{
	int c=0;
	int x1=Surf->w;
    int y1=Surf->h;
	div_t divresult;
	divresult = div (x1,PixelSize);
	x1=x1-divresult.rem;
	divresult = div (y1,PixelSize);
	y1=y1-divresult.rem;
	Surf=crop_surface(Surf, x1, y1);
	SDL_LockSurface(Surf);
	
    int bpp = Surf->format->BytesPerPixel;




	
    for(int x2=0; x2<x1; x2=x2+PixelSize)
    for(int y2=0; y2<y1; y2=y2+PixelSize)
    {
	
	int qR=0;
	int qG=0;
	int qB=0;
	int qA=0;
	c=0;
	for(int x=x2; x<x2+PixelSize; x++)
	for(int y=y2; y<y2+PixelSize; y++)
	{
	 Uint8 red, green, blue, alpha;
    Uint8 *p = (Uint8*)Surf->pixels + y * Surf->pitch + x * bpp;
    Uint32 pixelColor;
    switch(bpp)
    {
        case(1):
            pixelColor = *p;
            break;
        case(2):
            pixelColor = *(Uint16*)p;
            break;
        case(3):
            if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
                pixelColor = p[0] << 16 | p[1] << 8 | p[2];
            else
                pixelColor = p[0] | p[1] << 8 | p[2] << 16;
            break;
        case(4):
            pixelColor = *(Uint32*)p;
            break;
    }
    
    SDL_GetRGBA(pixelColor, Surf->format, &red, &green, &blue, &alpha);
    qR=qR+red;
    qG=qG+green;
    qB=qB+blue;
    qA=qA+alpha;
    c++;
    /*
    CArr[c].r=red;
    CArr[c].g=green;
    CArr[c].b=blue;
    CArr[c].a=alpha; */
    RArr[c]=red;
    GArr[c]=green;
    BArr[c]=blue;
	}
		qR=qR/(PixelSize*PixelSize);
		qG=qG/(PixelSize*PixelSize);
		qB=qB/(PixelSize*PixelSize);
		qA=qA/(PixelSize*PixelSize);
		if(MedianMode==1)
		{
		SortColors(PixelSize*PixelSize);
		}
		SDL_Rect recto;
		recto.x=x2;
		recto.y=y2;
		recto.w=PixelSize;
		recto.h=PixelSize;
		if(qA>200)
		{
		if(PaletteMode==false)
		{
		if(MedianMode==0)
		{
		SDL_FillRect(Surf, &recto, SDL_MapRGB(Surf->format, qR, qG, qB));
		}
		else
		{
		SDL_FillRect(Surf, &recto, SDL_MapRGB(Surf->format, RArr[(int)ceil((PixelSize*PixelSize)*MedianPoint)], GArr[(int)ceil((PixelSize*PixelSize)*MedianPoint)], BArr[(int)ceil((PixelSize*PixelSize)*MedianPoint)]));
		//SDL_FillRect(Surf, &recto, SDL_MapRGB(Surf->format, RArr[(PixelSize*PixelSize)/2], GArr[(PixelSize*PixelSize)/2], BArr[(PixelSize*PixelSize)/2]));
		}
		}
		else
		{
			SDL_Color CCol;
			if(MedianMode==0)
			 {
				 CCol=cPal.Clrs[cPal.GetNearestColor(qR, qG, qB)];
			 }
			 else
			 {
				 CCol=cPal.Clrs[cPal.GetNearestColor(RArr[(int)ceil((PixelSize*PixelSize)*MedianPoint)], GArr[(int)ceil((PixelSize*PixelSize)*MedianPoint)], BArr[(int)ceil((PixelSize*PixelSize)*MedianPoint)])];
			 }
			 SDL_FillRect(Surf, &recto, SDL_MapRGB(Surf->format, CCol.r, CCol.g, CCol.b));
		}
		}
		else
		{
			SDL_FillRect(Surf, &recto, SDL_MapRGBA(Surf->format, 0, 0, 0, 0));
		}
		
	}
	SDL_UnlockSurface(Surf);
	if(Save>0)
	{
	 std::string stringname=Paths[Save];
	 stringname.erase(0, 6);
	 std::string appendixer="Output/";
	 appendixer+=stringname;
	 appendixer+=".png";
	 IMG_SavePNG(Surf, appendixer.c_str());
	}
	if(clean==true)
	if((*give)!=NULL)SDL_DestroyTexture(*give);
	(*give)=SDL_CreateTextureFromSurface(Renderer, Surf);
	SDL_FreeSurface(Surf);
	
	
	return 0;	
}



int iniSDL()
{
if( SDL_Init( SDL_INIT_VIDEO ) < 0 ) { printf( "SDL konnte nicht initialisiert werden: %s\n", SDL_GetError() ); }
		else { 
		 if( !SDL_SetHint( SDL_HINT_RENDER_SCALE_QUALITY, "1" ) ) { printf( "Warning: Linear texture filtering not enabled!" ); }
		if(AntiA==true)
		{
		SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
		SDL_GL_SetAttribute(SDL_GL_MULTISAMPLEBUFFERS, 1);
	    SDL_GL_SetAttribute(SDL_GL_MULTISAMPLESAMPLES, 2);
		SDL_GL_SetAttribute(SDL_GL_ACCELERATED_VISUAL, 1);
		}
		  for(int i = 0; i < SDL_GetNumVideoDisplays(); ++i)
		{
		
		int should_be_zero = SDL_GetCurrentDisplayMode(i, &DMode);

		 if(should_be_zero != 0)
  	
 	    SDL_Log("SDL-Fehler bei der Ausgabe #%d: %s", i, SDL_GetError());

		 else
 	   

		
	   SDL_Log("Anzeige #%d: Modus: %dx%dpx @ %dhz. \n", i, DMode.w, DMode.h, DMode.refresh_rate);
		  }
 
		}
				if(FullScreen==1)
			  Window=SDL_CreateWindow("Wondrous Pixel Turtle", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, DMode.w, DMode.h, SDL_WINDOW_SHOWN | SDL_WINDOW_FULLSCREEN | SDL_WINDOW_OPENGL ); 
		else if(FullScreen==2)
			  Window=SDL_CreateWindow("Wondrous Pixel Turtle", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, DMode.w, DMode.h, SDL_WINDOW_SHOWN | SDL_WINDOW_BORDERLESS | SDL_WINDOW_OPENGL ); 
		else if(FullScreen==0)
			Window=SDL_CreateWindow("Wondrous Pixel Turtle", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, DMode.w, DMode.h, SDL_WINDOW_SHOWN | SDL_WINDOW_OPENGL | SDL_WINDOW_RESIZABLE ); 
		
	Renderer = SDL_CreateRenderer( Window, -1, SDL_RENDERER_ACCELERATED | SDL_RENDERER_PRESENTVSYNC ); 
		    
		
		 SDL_RenderSetLogicalSize(Renderer, 1920, 1080);
		 ScreenSurface = SDL_GetWindowSurface( Window );
		if(FullScreen==1)
			SDL_SetWindowFullscreen(Window, SDL_WINDOW_FULLSCREEN);
		if(FullScreen==2)
			SDL_SetWindowFullscreen(Window, SDL_WINDOW_BORDERLESS);
			
			   SDL_ShowCursor(SDL_ENABLE);
			     
//fonts
if( TTF_Init() == -1 ) { printf( "SDL_ttf could not initialize! SDL_ttf Error: %s\n", TTF_GetError() ); }	

//ini Sound!
if(Mono==false)
 {if( Mix_OpenAudio( 44100, MIX_DEFAULT_FORMAT, 2, 2048 ) < 0 ) { printf( "Ton-Wiedergabe nicht möglich :(: %s\n", Mix_GetError() );}}
 else
 if( Mix_OpenAudio( 44100, MIX_DEFAULT_FORMAT, 1, 2048 ) < 0 ) { printf( "Ton-Wiedergabe nicht möglich :(: %s\n", Mix_GetError() );}
	Mix_AllocateChannels(48);
	//ini gamepad
	   SDL_InitSubSystem(SDL_INIT_JOYSTICK);
	   SDL_InitSubSystem(SDL_INIT_GAMECONTROLLER);
	   SDL_SetHint(SDL_HINT_JOYSTICK_ALLOW_BACKGROUND_EVENTS,"1");
	   
	 
     SDL_ShowCursor(SDL_ENABLE);
     return 0;	
}

SDL_Texture* loadTexture( std::string path ) { 
	SDL_Texture* newTexture = NULL; 
		SDL_Surface* loadedSurface = IMG_Load( path.c_str() ); 
	if( loadedSurface == NULL ) { printf( "Unable to load image %s! SDL_image Error: %s\n", path.c_str(), IMG_GetError() ); } else { 
		newTexture = SDL_CreateTextureFromSurface( Renderer, loadedSurface ); if( newTexture == NULL ) { printf( "Unable to create texture from %s! SDL Error: %s\n", path.c_str(), SDL_GetError() ); } 
		
		SDL_FreeSurface( loadedSurface ); } return newTexture; }
		
int RecoCTex(bool instant=false)
{
	if(instant==false)
	SetRefresh=true;
	else
	Recoulor(RawImages[CTex], &Images[CTex]);
	return 0;
}

int WriteProfile(std::string mainfile)
{
  std::ofstream myfile;
  std::string this1="Profiles/";
  this1+=mainfile;
  myfile.open (this1);
  myfile << "PixelSize\n";
  myfile << PixelSize <<"\n";
  myfile << "MedianMode\n";
  myfile << MedianMode <<"\n";
  myfile << "PaletteMode\n";
  myfile << PaletteMode <<"\n";
  myfile << "PaletteSelect\n";
  myfile << PaletteSelect <<"\n";
  myfile << "RefX\n";
  myfile << RefX <<"\n";
  myfile << "RefY\n";
  myfile << RefY <<"\n";
  myfile << "RefZ\n";
  myfile << RefZ <<"\n";
  myfile.close();
  return 0;
}

int UpdateScrollList()
{
	int t=0;
	for(int i=27; i<41; i++)
	{
		t++;
		if(LoadMode==1)
		ButtonS[i].Text=ProPaths[Scrollpoint+t];
		if(LoadMode==2)
		ButtonS[i].Text=PaletteStack[Scrollpoint+t].Name;
		
	}
	return 0;
}

int SaveInput()
{
	Inmode=false;
	ButtonS[23].Unlocked=false;
	ButtonS[24].Unlocked=false;
	ButtonS[25].Unlocked=false;
	
	if(InTarg==1)
	{
		WriteProfile(Input.c_str());
	}
	if(InTarg==2)
	{
		PixelSize=atoi(Input.c_str());
		if(PixelSize<2)PixelSize=2;
		RecoCTex();
	}
    if(InTarg==3)
	{
		Zoomfactor=atof(Input.c_str());
		RecoCTex();
	}
	 if(InTarg==4)
	{
		MedianPoint=atof(Input.c_str());
		RecoCTex();
	}
	
	Input="";
	
	return 0;
}

int loadProfile(std::string mainfile)
{
			std::ifstream file;
	
			std::string str;
	
			file.open(mainfile.c_str());
			while (std::getline(file, str))
			{
			char * writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
			if(speicher=="PixelSize"){PixelSize=atoi(str.c_str());}
			if(speicher=="MedianMode"){MedianMode=atoi(str.c_str());}		
			if(speicher=="MedianPoint"){MedianPoint=atof(str.c_str());}		
			if(speicher=="PaletteMode"){PaletteMode=atoi(str.c_str());} 		
			if(speicher=="PaletteSelect"){PaletteSelect=atoi(str.c_str()); cPal=PaletteStack[PaletteSelect];}		
			if(speicher=="RefX"){RefX=atof(str.c_str());}		
			if(speicher=="RefY"){RefY=atof(str.c_str());}		
			if(speicher=="RefZ"){RefZ=atof(str.c_str());}				
				delete[] writable;
				speicher=str;
			}
		file.close();	
		return 0;
}


int TriggerAction(int A=0)
{
	if(A==0)
	{
		//std::cout << "Do nothing" << std::endl;
	}
	if(A==1)
	{
		CTex--;
		if(CTex==0)CTex=Pathn;
		RecoCTex(true);
	}
	if(A==2)
	{
		CTex++;
		if(CTex>Pathn)CTex=1;
		RecoCTex(true);
	}
	if(A==3)
	{
		MedianMode--;
		if(MedianMode<0)MedianMode=2;
		RecoCTex(true);
	}
	if(A==5)
	{
		MedianMode++;
		if(MedianMode>2)MedianMode=0;
		RecoCTex(true);
	}
	if(A==4)
	{
		if(MedianPoint>0.05)
		MedianPoint=MedianPoint-0.05;
		RecoCTex(true);
	}
	if(A==6)
	{
		if(MedianPoint<0.95)
		MedianPoint=MedianPoint+0.05;
		RecoCTex(true);
	}
	if(A==7)
	{
		if(PixelSize>1)
		PixelSize--;
		RecoCTex(true);
	}
	if(A==8)
	{
		PixelSize++;
		RecoCTex(true);
	}
	if(A==9)
	{
	Zoomfactor=Zoomfactor-0.01;
	}
	if(A==10)
	{
	Zoomfactor=Zoomfactor+0.01;
	}
	if(A==11)
	{
	PaletteSelect--;
	if(PaletteSelect==0)PaletteSelect=APals;
	cPal=PaletteStack[PaletteSelect];
	RecoCTex();
	}
	if(A==12)
	{
	PaletteSelect++;
	if(PaletteSelect>APals)PaletteSelect=1;
	cPal=PaletteStack[PaletteSelect];
	RecoCTex();
	}
	if(A==13)
	{
		LoadMode=1;
		for(int i=26; i<44; i++)
		 ButtonS[i].Unlocked=true;
		 UpdateScrollList();
	}
	if(A==18)
	{
		SaveInput();
	}
	if(A==38)
	{
		LoadMode=2;
				for(int i=26; i<44; i++)
		 ButtonS[i].Unlocked=true;
		 UpdateScrollList();
	}
	if(A==14)
	{
	Inmode=true;
	InTarg=1;
	Input="";
	
	ButtonS[23].Unlocked=true;
	ButtonS[24].Unlocked=true;
	ButtonS[25].Unlocked=true;
	
	ButtonS[23].Text="Enter Name";
	ButtonS[24].Text="";
	ButtonS[25].Text="Save";
	}
	if(A==15)
	{
	Recoulor(RawImages[CTex], &Images[CTex], true, CTex);
	}
	if(A==16)
	{
	for(int i=1; i<Pathn+1; i++)
	Recoulor(RawImages[i], &Images[i], true, i);
	}
	if(A==17)
	{
	if(PaletteMode==true)PaletteMode=false;
	else PaletteMode=true;
	RecoCTex();
	}
	if(A==19)
	{
	Inmode=true;
	InTarg=2;
	Input="";
	
	ButtonS[23].Unlocked=true;
	ButtonS[24].Unlocked=true;
	ButtonS[25].Unlocked=true;
	
	ButtonS[23].Text="Enter Size";
	ButtonS[24].Text="";
	ButtonS[25].Text="Save";
	}
	if(A==20)
	{
	Inmode=true;
	InTarg=3;
	Input="";
	
	ButtonS[23].Unlocked=true;
	ButtonS[24].Unlocked=true;
	ButtonS[25].Unlocked=true;
	
	ButtonS[23].Text="Enter Zoom";
	ButtonS[24].Text="";
	ButtonS[25].Text="Save";
	}
	if(A>20 && A<35)
	{
	if(LoadMode==1)loadProfile(ProPaths[Scrollpoint+(A-20)]);
	if(LoadMode==2)
	{
		PaletteSelect=Scrollpoint+(A-20);
		cPal=PaletteStack[PaletteSelect];
	}
	for(int i=26; i<44; i++)
		 ButtonS[i].Unlocked=false;
		 
	RecoCTex();
	}
	if(A==35)
	{
		for(int i=26; i<44; i++)
		 ButtonS[i].Unlocked=false;
	}
	
	if(A==36)
	{
		if(Scrollpoint>0)Scrollpoint--;
		UpdateScrollList();
	}
	
	if(A==37)
	{
		if(Scrollpoint<985)Scrollpoint++;
		UpdateScrollList();
	}
	if(A==39)
	{
	Inmode=true;
	InTarg=4;
	Input="";
	
	ButtonS[23].Unlocked=true;
	ButtonS[24].Unlocked=true;
	ButtonS[25].Unlocked=true;
	
	ButtonS[23].Text="Enter Medianpoint";
	ButtonS[24].Text="";
	ButtonS[25].Text="Save";
	}
	return 0;
}

int CheckButtonClick(int x, int y)
{
	for(int i=0; i<500; i++)
	{
			if(ButtonS[i].Unlocked==true)
			{
				if(x>=ButtonS[i].x && y>=ButtonS[i].y && x<=ButtonS[i].x+ButtonS[i].w && y<=ButtonS[i].y+ButtonS[i].h)
				{
					//std::cout << "Button " << i << " was smashed!!1" << std::endl;
					if(ButtonS[i].Action!=0){TriggerAction(ButtonS[i].Action);}
				}
			}
	}
	return 0;
}



int LastClick=0;


int Events()
{
	//Mouseman

		 int Mx1;
		 int My1;
		 int out=0;
		 int returner=0;
		 float xrel=0;
		 float yrel=0;
		 SDL_DisplayMode DM;
		 int gx, gy;
		 float offsetterY;
		 float offsetterX;
		 
		 //Adjact X/Y-Values to logical Rendersize

		
		SDL_GetWindowSize(Window, &DM.w,  &DM.h);
		SDL_RenderGetLogicalSize(Renderer, &gx, &gy);
			
		
		float DMH=DM.h;
		float DMW=DM.w;
		float GX=gx;
		float GY=gy;
		int Mx=0;
		int My=0;
		if(FullScreen==true)
		{
		offsetterY=(float)((DMH-((DMW/GX)*GY))/2);
		offsetterX=(float)((DMW-((DMH/GY)*GX))/2);
		
		if(offsetterX<offsetterY)offsetterX=0;
		else offsetterY=0;
		
		//std::cout << "OffsetterX: " << offsetterX << " Offsetter Y: " << offsetterY << std::endl;
		xrel=(float)GX/(DMW-(offsetterX*2));
		yrel=(float)GY/(DMH-(offsetterY*2));
		
		
		 SDL_GetMouseState(&Mx1, &My1); //Get Mouse State,
		 
		  //Adjact to Logical Rendersize
		  Mx=(Mx1-offsetterX)*xrel;
		  My=(My1-offsetterY)*yrel;	
		 }
		  
		  if(FullScreen==false) //no fullscreen?
		  {
			
			 float ratio=(float)DM.w/DM.h;
			 float nRatio=(float)1920/1080;
			 float Factor=0;
			 int mW=0;
			 int mH=0;
			  //std::cout << "Windowed. Ratio: " << ratio << " ";
			 if(ratio<nRatio)
			 {
				// std::cout << "Thinner than original."; 
				 //getting hight
				 float weidth=DM.w;
				 float adaptor=weidth/GX;
				 Factor=adaptor;
				 float height=GY*adaptor;
				 //std::cout << height << " ";
				 mH=(DM.h-height)/2;
				 //std::cout << " need to remove " << mH << " ";
			 }
			 if(ratio>nRatio) 
			 {
				 //std::cout << "Fatter than original";
				 float height=DM.h;
				 float adaptor=height/GY;
				 Factor=adaptor;
				 float weidth=GX*adaptor;
				 //std::cout << weidth << " ";
				 mW=(DM.w-weidth)/2;
				 //std::cout << " need to remove " << mW << " ";
			 }
			 SDL_GetMouseState(&Mx1, &My1);
			 Mx=((Mx1)-mW)/Factor;
			 My=((My1)-mH)/Factor;
			 //std::cout << std::endl;
		  }
		  
	
		 
		  //if Button is pressed:
		  
		  if(SDL_GetMouseState(&Mx1, &My1) & SDL_BUTTON(SDL_BUTTON_LEFT))
		  {
			  if(LastClick<=0)
			  {
			  CheckButtonClick(Mx, My);
			  //std::cout << "Click X: " << Mx << " Y: " << My << std::endl;
			  LastClick=5;
			 }
			  
		  }
		  else
		  {
			  if(LastClick>0)LastClick--;
		  }

//Mouseman end
	while( SDL_PollEvent( &event ) ){
		switch( event.type ){
		  case SDL_KEYDOWN:
		  {
			if(Inmode==false)
			{
			if(event.key.keysym.sym==SDLK_ESCAPE)
				{
					running=false;
				 }
			if(event.key.keysym.sym==SDLK_LEFT)
				{
					CTex--;
					if(CTex==0)CTex=Pathn;
					RecoCTex(true);
				 }
				 if(event.key.keysym.sym==SDLK_RIGHT)
				{
					CTex++;
					if(CTex>Pathn)CTex=1;
					RecoCTex(true);
				 }
				 if(event.key.keysym.sym==SDLK_UP)
				{
					PixelSize++;
					RecoCTex();
				 }
				 if(event.key.keysym.sym==SDLK_DOWN)
				{
					if(PixelSize>1)PixelSize--;
					RecoCTex();
				 }
				 if(event.key.keysym.sym==SDLK_KP_PLUS)
				{
					Zoomfactor=Zoomfactor+0.01;
				}
				 if(event.key.keysym.sym==SDLK_KP_MINUS)
				{
					Zoomfactor=Zoomfactor-0.01;
				}
				if(event.key.keysym.sym==SDLK_s)
				{
					if(PaletteMode==true)PaletteMode=false;
					else PaletteMode=true;
					RecoCTex();
				}
				if(event.key.keysym.sym==SDLK_a)
				{
					PaletteSelect--;
					if(PaletteSelect==0)PaletteSelect=APals;
					cPal=PaletteStack[PaletteSelect];
					RecoCTex();
				}
				if(event.key.keysym.sym==SDLK_d)
				{
					PaletteSelect++;
					if(PaletteSelect>APals)PaletteSelect=1;
					cPal=PaletteStack[PaletteSelect];
					RecoCTex();
				}
				if(event.key.keysym.sym==SDLK_c)
				{
					MedianMode++;
					if(MedianMode>2)MedianMode=0;
					RecoCTex();
				}
				if(event.key.keysym.sym==SDLK_x)
				{
					if(MedianPoint>0.05)MedianPoint=MedianPoint-0.05;
					RecoCTex();
				}
				if(event.key.keysym.sym==SDLK_v)
				{
					if(MedianPoint<0.95)MedianPoint=MedianPoint+0.05;
					RecoCTex();
				}
					if(event.key.keysym.sym==SDLK_RETURN)
				{
					Recoulor(RawImages[CTex], &Images[CTex], true, CTex);
				}
				if(event.key.keysym.sym==SDLK_RSHIFT)
				{
				 for(int i=1; i<Pathn+1; i++)
				  Recoulor(RawImages[i], &Images[i], true, i);
				}
				}
				else
				{
				if(event.key.keysym.sym==SDLK_BACKSPACE)
					{
							Input=Input.substr(0, Input.size()-1);
							ButtonS[24].Text=Input;
					}
					if(event.key.keysym.sym==SDLK_RETURN)
					{
							SaveInput();
					}
				}
				
			 }
			 break;
			  case SDL_TEXTINPUT:
			  {
				 if(Inmode==true)
				 {
				 Input+=event.text.text;
				 ButtonS[24].Text=Input;
				 //std::cout << Input << std::endl;
				 }
			  }
			  break;
		 }
		}
	return 0;	
}


int ManageButtons(SDL_Renderer* rend=Renderer)
{
		ButtonS[5].Text="Medianmode ";
		ButtonS[5].Text+=std::to_string(MedianMode);
		ButtonS[6].Text="Medianpoint ";
		ButtonS[6].Text+=std::to_string(MedianPoint);
		ButtonS[6].Text.resize(16);
		ButtonS[10].Text="Pixelsize ";
		ButtonS[10].Text+=std::to_string(PixelSize);
		ButtonS[13].Text="Zoom ";
		ButtonS[13].Text+=std::to_string(Zoomfactor);
		ButtonS[13].Text.resize(10);
		ButtonS[15].Text="Palette ";
		if(PaletteMode==true)
		ButtonS[15].Text+=" On";
		else
		ButtonS[15].Text+=" Off";
		ButtonS[17].Text=PaletteStack[PaletteSelect].Name;
		
	for(int i=0; i<500; i++)
	{
			if(ButtonS[i].Unlocked==true)
			{
				ButtonS[i].Draw(Renderer);
			}
	}
	return 0;
}

int DefPals()
{
	cPal.AddColor(0, 0, 0);
	cPal.AddColor(20, 20, 20);
	cPal.AddColor(255, 0, 0);
	cPal.AddColor(0, 255, 0);
	cPal.AddColor(0, 0, 255);
	cPal.AddColor(80, 80, 80);
	cPal.AddColor(125, 80, 80);
	cPal.AddColor(80, 125, 80);
	cPal.AddColor(80, 80, 125);
	cPal.AddColor(200, 200, 230);
	cPal.AddColor(255, 200, 200);
	cPal.AddColor(200, 230, 200);
	cPal.AddColor(180, 60, 100);
	cPal.AddColor(60, 180, 100);
	cPal.AddColor(100, 180, 60);
	cPal.AddColor(255, 255, 255);
	return 0;
}

int DefineGUI()
{
	ButtonS[1].Unlocked=true;
	ButtonS[1].x=0;
	ButtonS[1].y=0;
	ButtonS[1].w=50;
	ButtonS[1].h=50;
	ButtonS[1].Action=1;
	ButtonS[1].Text="<";
	
	ButtonS[2].Unlocked=true;
	ButtonS[2].x=0;
	ButtonS[2].y=50;
	ButtonS[2].w=50;
	ButtonS[2].h=50;
	ButtonS[2].Action=2;
	ButtonS[2].Text=">";
	
	ButtonS[3].Unlocked=true;
	ButtonS[3].x=60;
	ButtonS[3].y=0;
	ButtonS[3].w=20;
	ButtonS[3].h=50;
	ButtonS[3].Action=3;
	ButtonS[3].Text="-";
	
	ButtonS[4].Unlocked=true;
	ButtonS[4].x=60;
	ButtonS[4].y=50;
	ButtonS[4].w=20;
	ButtonS[4].h=50;
	ButtonS[4].Action=4;
	ButtonS[4].Text="-";
	
	ButtonS[5].Unlocked=true;
	ButtonS[5].x=80;
	ButtonS[5].y=0;
	ButtonS[5].w=300;
	ButtonS[5].h=50;
	ButtonS[5].Action=0;
	ButtonS[5].Text="Medianmode";
	
	ButtonS[6].Unlocked=true;
	ButtonS[6].x=80;
	ButtonS[6].y=50;
	ButtonS[6].w=300;
	ButtonS[6].h=50;
	ButtonS[6].Action=39;
	ButtonS[6].Text="Medianpoint";
	
	ButtonS[7].Unlocked=true;
	ButtonS[7].x=380;
	ButtonS[7].y=0;
	ButtonS[7].w=20;
	ButtonS[7].h=50;
	ButtonS[7].Action=5;
	ButtonS[7].Text="+";
	
	ButtonS[8].Unlocked=true;
	ButtonS[8].x=380;
	ButtonS[8].y=50;
	ButtonS[8].w=20;
	ButtonS[8].h=50;
	ButtonS[8].Action=6;
	ButtonS[8].Text="+";
	
	ButtonS[9].Unlocked=true;
	ButtonS[9].x=410;
	ButtonS[9].y=0;
	ButtonS[9].w=20;
	ButtonS[9].h=50;
	ButtonS[9].Action=7;
	ButtonS[9].Text="-";
	
	ButtonS[10].Unlocked=true;
	ButtonS[10].x=430;
	ButtonS[10].y=0;
	ButtonS[10].w=300;
	ButtonS[10].h=50;
	ButtonS[10].Action=19;
	ButtonS[10].Text="Pixelsize";
	
	ButtonS[11].Unlocked=true;
	ButtonS[11].x=730;
	ButtonS[11].y=0;
	ButtonS[11].w=20;
	ButtonS[11].h=50;
	ButtonS[11].Action=8;
	ButtonS[11].Text="+";
	
	
	int b=11;
	
	b++;
	int xS=410;
	int yS=50;
	ButtonS[b].Unlocked=true;
	ButtonS[b].x=xS;
	ButtonS[b].y=yS;
	ButtonS[b].w=20;
	ButtonS[b].h=50;
	ButtonS[b].Action=9;
	ButtonS[b].Text="-";
	
	b++;
	
	ButtonS[b].Unlocked=true;
	ButtonS[b].x=xS+20;
	ButtonS[b].y=yS;
	ButtonS[b].w=300;
	ButtonS[b].h=50;
	ButtonS[b].Action=20;
	ButtonS[b].Text="Zoom";
	
	b++;
	
	ButtonS[b].Unlocked=true;
	ButtonS[b].x=xS+320;
	ButtonS[b].y=yS;
	ButtonS[b].w=20;
	ButtonS[b].h=50;
	ButtonS[b].Action=10;
	ButtonS[b].Text="+";
	
	b++;
	 xS=760;
	 yS=0;

	

	
	ButtonS[b].Unlocked=true;
	ButtonS[b].x=xS+0;
	ButtonS[b].y=yS;
	ButtonS[b].w=340;
	ButtonS[b].h=50;
	ButtonS[b].Action=17;
	ButtonS[b].Text="Palette";
	
	b++;
	xS=760;
	yS=50;
	ButtonS[b].Unlocked=true;
	ButtonS[b].x=xS;
	ButtonS[b].y=yS;
	ButtonS[b].w=20;
	ButtonS[b].h=50;
	ButtonS[b].Action=11;
	ButtonS[b].Text="-";
	
	b++;
	
	ButtonS[b].Unlocked=true;
	ButtonS[b].x=xS+20;
	ButtonS[b].y=yS;
	ButtonS[b].w=300;
	ButtonS[b].h=50;
	ButtonS[b].Action=38;
	ButtonS[b].Text=" ";
	
	b++;
	
	ButtonS[b].Unlocked=true;
	ButtonS[b].x=xS+320;
	ButtonS[b].y=yS;
	ButtonS[b].w=20;
	ButtonS[b].h=50;
	ButtonS[b].Action=12;
	ButtonS[b].Text="+";
	
	  b++;
	 xS=1110;
	 yS=0;

	

	
	ButtonS[b].Unlocked=true;
	ButtonS[b].x=xS+0;
	ButtonS[b].y=yS;
	ButtonS[b].w=340;
	ButtonS[b].h=50;
	ButtonS[b].Action=13;
	ButtonS[b].Text="Load Profile";
	
	  b++;
	 xS=1110;
	 yS=50;

	

	
	ButtonS[b].Unlocked=true;
	ButtonS[b].x=xS+0;
	ButtonS[b].y=yS;
	ButtonS[b].w=340;
	ButtonS[b].h=50;
	ButtonS[b].Action=14;
	ButtonS[b].Text="Save Profile";
	
		b++;
	 xS=1920-350;
	 yS=0;

	

	
	ButtonS[b].Unlocked=true;
	ButtonS[b].x=xS+0;
	ButtonS[b].y=yS;
	ButtonS[b].w=340;
	ButtonS[b].h=50;
	ButtonS[b].Action=15;
	ButtonS[b].Text="Convert Picture";
	
	b++;
	 xS=1920-350;
	 yS=50;

	

	
	ButtonS[b].Unlocked=true;
	ButtonS[b].x=xS+0;
	ButtonS[b].y=yS;
	ButtonS[b].w=340;
	ButtonS[b].h=50;
	ButtonS[b].Action=16;
	ButtonS[b].Text="Convert All";
	
	b++;
	 xS=1920/4;
	 yS=500;

	

	
	ButtonS[b].Unlocked=false;
	ButtonS[b].x=xS+0;
	ButtonS[b].y=yS;
	ButtonS[b].w=1920/2;
	ButtonS[b].h=50;
	ButtonS[b].Action=0;
	ButtonS[b].Solid=true;
	ButtonS[b].Text="Enter Name";
	
	b++;
	
	ButtonS[b].Unlocked=false;
	ButtonS[b].x=xS+0;
	ButtonS[b].y=yS+50;
	ButtonS[b].w=1920/2;
	ButtonS[b].h=50;
	ButtonS[b].Action=0;
	ButtonS[b].Solid=true;
	ButtonS[b].Text="";
	
	b++;
	
	ButtonS[b].Unlocked=false;
	ButtonS[b].x=xS+0;
	ButtonS[b].y=yS+100;
	ButtonS[b].w=1920/2;
	ButtonS[b].h=50;
	ButtonS[b].Action=18;
	ButtonS[b].Solid=true;
	ButtonS[b].Text="Save";
	
    b++;
     xS=1920/4;
	 yS=100;
	
	ButtonS[b].Unlocked=false;
	ButtonS[b].x=xS+0;
	ButtonS[b].y=yS+100;
	ButtonS[b].w=1920/2;
	ButtonS[b].h=50;
	ButtonS[b].Action=18;
	ButtonS[b].Solid=true;
	ButtonS[b].BGColor.r=100;
	ButtonS[b].BGColor.g=0;
	ButtonS[b].BGColor.b=100;
	ButtonS[b].Text="Load";
	
	for(int i=1; i<15; i++)
	{
	  b++;
	 xS=1920/4;
	 yS=yS+50;
	
	ButtonS[b].Unlocked=false;
	ButtonS[b].x=xS+0;
	ButtonS[b].y=yS+100;
	ButtonS[b].w=1920/2;
	ButtonS[b].h=50;
	ButtonS[b].Action=20+i; //21-34
	ButtonS[b].Solid=true;
	ButtonS[b].Text=ProPaths[i]; //ProPaths[i];	
		
	}
	
	  b++;
     xS=1920/4;
	 yS=yS+50;
	
	ButtonS[b].Unlocked=false;
	ButtonS[b].x=xS+0;
	ButtonS[b].y=yS+100;
	ButtonS[b].w=100;
	ButtonS[b].h=50;
	ButtonS[b].Action=35;
	ButtonS[b].Solid=true;
	ButtonS[b].BGColor.r=100;
	ButtonS[b].BGColor.g=0;
	ButtonS[b].BGColor.b=100;
	ButtonS[b].Text="Back";
	
	    b++;
     xS=(1920/4)+(1920/2);
	 yS=100;
	
	ButtonS[b].Unlocked=false;
	ButtonS[b].x=xS+0;
	ButtonS[b].y=yS+100;
	ButtonS[b].w=70;
	ButtonS[b].h=50;
	ButtonS[b].Action=36;
	ButtonS[b].Solid=true;
	ButtonS[b].BGColor.r=100;
	ButtonS[b].BGColor.g=0;
	ButtonS[b].BGColor.b=100;
	ButtonS[b].Text=" ^";
	
	b++;
     xS=(1920/4)+(1920/2);
	 yS=100;
	
	ButtonS[b].Unlocked=false;
	ButtonS[b].x=xS+0;
	ButtonS[b].y=yS+800;
	ButtonS[b].w=70;
	ButtonS[b].h=50;
	ButtonS[b].Action=37;
	ButtonS[b].Solid=true;
	ButtonS[b].BGColor.r=100;
	ButtonS[b].BGColor.g=0;
	ButtonS[b].BGColor.b=100;
	ButtonS[b].Text=" v";
	
	
	
	
	
	
	
	
	
	return 0;
}

int main()
{
iniSDL();
DefPals();
//loadPalettes("Pals.txt");
GetPaletteList();
GetProfileList();
loadProfile(ProPaths[1]);
DefineGUI();
cPal=PaletteStack[PaletteSelect];
GetInputList();
Recoulor(RawImages[CTex], &Images[CTex]);


while(running==true)
{
	
	Events();
	
	if(RefreshTimer>0)
	 {
		 RefreshTimer--;
	 }
	 else
	 {
		 RefreshTimer=10;
		 if(SetRefresh==true)
		 {
			 Recoulor(RawImages[CTex], &Images[CTex]);
			 SetRefresh=false;
		 }
		 
	 }

		SDL_SetRenderDrawColor(Renderer, 255, 255, 255, 255);
		SDL_RenderClear( Renderer );
		
			SDL_Rect FillerFee;
			FillerFee.x=0;
			FillerFee.y=0;
			FillerFee.w=1920;
			FillerFee.h=1080;
			SDL_RenderFillRect(Renderer, &FillerFee);
			FillerFee.x=50;
			FillerFee.y=100;
			SDL_QueryTexture(Images[CTex], NULL, NULL, &FillerFee.w, &FillerFee.h);
			FillerFee.w=FillerFee.w*Zoomfactor;
			FillerFee.h=FillerFee.h*Zoomfactor;
			SDL_RenderCopy( Renderer, Images[CTex], NULL, &FillerFee);
			FillerFee.x=0;
			FillerFee.y=0;
			FillerFee.w=1920;
			FillerFee.h=100;
			SDL_SetRenderDrawColor(Renderer, 100, 0, 100, 255);
			SDL_RenderFillRect(Renderer, &FillerFee);
			ManageButtons(Renderer);
		
		SDL_RenderPresent( Renderer );


}
}
